<?php

  ini_set("include_path", ".:./media:./media/includes");

function regex_array_keys($arr, $pattern){

	$pattern = '/'.$pattern .'/';
	$results = array();
 
	if(!is_array($arr))
        	return false;
 
	foreach($arr as $key => $val){
		if(!is_array($key)) {
#			if(preg_match($pattern,$key)) {
			if(preg_match($pattern,strtolower($val))) {
				array_push($results,$val);
			}
		}
	}
 
	return $results;
 }

# Default to ALL in 4.0 and no class
$version = '4.0';
if (array_key_exists('version',$_GET)) {
	$version = $_GET['version'];
}

$class = '';
if (array_key_exists('class',$_GET)) {
	$class = $_GET['class'];
}

$module = 'ALL';
if (array_key_exists('module',$_GET)) {
	$module = $_GET['module'];
}

$potential_files = false;

if (!empty($class)) {
	$class = strtolower( $class );

	if ($class == "//radio")
		$file = "http://radio.kde.org";
	else {

		$path="classmaps/classmap-$version-$module.inc";
		if (file_exists($path)) {
			include_once $path;
			$potential_files = regex_array_keys($map, $class);
			if (count($potential_files) == 0) {
			# Nothing found, return to index via bailout below.
				$file='';
			} else 	if (count($potential_files) == 1) {
				# Single results are redirected immediately
				$url = array_keys($map, $potential_files[0]);
				$file= $url[0];
			} else {
				# TODO: For now, multiple results bails out.
				$file='';
			}
		}
	}	
}
if (empty($file)) {
	$file="/index.php?miss=1&class=$class";
}


if (count($potential_files) <= 1) {
	print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Struct//EN" "DTD/xhtml1-strict.dtd">';
	# Remainder in text block below
?>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
        <head>
                <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
                <meta http-equiv="refresh" content="0; url=<?php echo $file;?>"/>
        </head>
</html>
<?php
} else {
	# Multiple results, build page
	$page_title='APIDOX Search Results';
	include 'header.inc';
	echo "<h2>Multiple results found</h2>";
	echo "<ul>";
	$submodule_path="classmaps/componentmap-$version-$module.inc";
	if (file_exists($submodule_path)) {
			include_once $submodule_path;
	}
	foreach ($potential_files as $file) {
		$file_url_array = array_keys($map, $file);
		$file_url = $file_url_array[0];
		$file=str_replace("http://api.kde.org/","",$file);
		list($c,$m,$sm,$tmp)=split('/',$file_url,4);
		$c=str_replace("-api","",$c); # KDE version
		$m=str_replace("-apidocs","",$m); # module
		$bclass=str_replace("_1_1","::",str_replace(".html","",str_replace("class","",basename($file_url))));
		$component_array = ${m}.'_component';
		$component = ${$component_array}[$sm];
		list($component_name, $component_url,$tmp) = split(',',$component,2);
		echo "<li><a href=\"$file_url\">$file</a> in $bclass, module $m $c, component <a href=\"$component_url\">$component_name</a></li>\n";	
	} 
	echo "</ul>";
	include 'footer.inc';
}
?>
